> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Update security group rule

> Update the configuration of an existing security group rule.

**Deprecated** Use `/v2/security_groups/<project_id>/<region_id>/<group_id>/rules/<rule_id>`
to delete and `/v2/security_groups/<project_id>/<region_id>/<group_id>/rules` to create a new rule.



## OpenAPI

````yaml /api-reference/services_documented/cloud_api.yaml put /cloud/v1/securitygrouprules/{project_id}/{region_id}/{rule_id}
openapi: 3.1.0
info:
  title: Gcore OpenAPI – Cloud API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-15T06:37:28.230198+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: Bare Metal
    x-displayName: Bare Metal
  - name: Container as a Service
    x-displayName: Container as a Service
  - name: Cost Reports
    x-displayName: Cost Reports
  - name: DDoS Protection
    x-displayName: DDoS Protection
  - name: Everywhere Inference
    x-displayName: Everywhere Inference
  - name: Everywhere Inference Apps
    x-displayName: Everywhere Inference Apps
  - name: File Shares
    x-displayName: File Shares
  - name: Floating IPs
    x-displayName: Floating IPs
  - name: Function as a Service
    x-displayName: Function as a Service
  - name: GPU Bare Metal
    x-displayName: GPU Bare Metal
  - name: GPU Virtual
    x-displayName: GPU Virtual
  - name: IP Ranges
    x-displayName: IP Ranges
  - name: Images
    x-displayName: Images
  - name: Instances
    x-displayName: Instances
  - name: Load Balancers
    x-displayName: Load Balancers
  - name: Logging
    x-displayName: Logging
  - name: Managed Kubernetes
    x-displayName: Managed Kubernetes
  - name: Managed PostgreSQL
    x-displayName: Managed PostgreSQL
  - name: Networks
    x-displayName: Networks
  - name: Placement Groups
    x-displayName: Placement Groups
  - name: Projects
    x-displayName: Projects
  - name: Quotas
    x-displayName: Quotas
  - name: Regions
    x-displayName: Regions
  - name: Registry
    x-displayName: Registry
  - name: Reservations
    x-displayName: Reservations
  - name: Reserved IPs
    x-displayName: Reserved IPs
  - name: Routers
    x-displayName: Routers
  - name: SSH Keys
    x-displayName: SSH Keys
  - name: Secrets
    x-displayName: Secrets
  - name: Security Groups
    x-displayName: Security Groups
  - name: Snapshot Schedules
    x-displayName: Snapshot Schedules
  - name: Snapshots
    x-displayName: Snapshots
  - name: Tasks
    x-displayName: Tasks
  - name: User Actions
    x-displayName: User Actions
  - name: User Role Assignments
    x-displayName: User Role Assignments
  - name: Volumes
    x-displayName: Volumes
paths:
  /cloud/v1/securitygrouprules/{project_id}/{region_id}/{rule_id}:
    put:
      tags:
        - Security Groups
      summary: Update security group rule
      description: >-
        Update the configuration of an existing security group rule.


        **Deprecated** Use
        `/v2/security_groups/<project_id>/<region_id>/<group_id>/rules/<rule_id>`

        to delete and
        `/v2/security_groups/<project_id>/<region_id>/<group_id>/rules` to
        create a new rule.
      operationId: SecurityGroupRuleInstanceViewSet.put
      parameters:
        - in: path
          name: project_id
          required: true
          description: Project ID
          schema:
            description: Project ID
            example: 1
            examples:
              - 1
            title: Project Id
            type: integer
        - in: path
          name: region_id
          required: true
          description: Region ID
          schema:
            description: Region ID
            example: 1
            examples:
              - 1
            title: Region Id
            type: integer
        - in: path
          name: rule_id
          required: true
          description: Rule ID
          schema:
            description: Rule ID
            example: 024a29e9-b4b7-4c91-9a46-505be123d9f8
            examples:
              - 024a29e9-b4b7-4c91-9a46-505be123d9f8
            format: uuid4
            title: Rule Id
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ChangeSecurityGroupRuleSerializer'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SecurityGroupRuleSerializer'
      deprecated: true
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from gcore import Gcore

            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )
            security_group_rule = client.cloud.security_groups.rules.replace(
                rule_id="024a29e9-b4b7-4c91-9a46-505be123d9f8",
                project_id=1,
                region_id=1,
                direction="ingress",
                security_group_id="00000000-0000-4000-8000-000000000000",
            )
            print(security_group_rule.id)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/cloud\"\n\t\"github.com/G-Core/gcore-go/option\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tsecurityGroupRule, err := client.Cloud.SecurityGroups.Rules.Replace(\n\t\tcontext.TODO(),\n\t\t\"024a29e9-b4b7-4c91-9a46-505be123d9f8\",\n\t\tcloud.SecurityGroupRuleReplaceParams{\n\t\t\tProjectID:       gcore.Int(1),\n\t\t\tRegionID:        gcore.Int(1),\n\t\t\tDirection:       cloud.SecurityGroupRuleReplaceParamsDirectionIngress,\n\t\t\tSecurityGroupID: \"00000000-0000-4000-8000-000000000000\",\n\t\t},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", securityGroupRule.ID)\n}\n"
components:
  schemas:
    ChangeSecurityGroupRuleSerializer:
      properties:
        description:
          description: Rule description
          example: Some description
          examples:
            - Some description
          maxLength: 255
          title: Description
          type: string
        direction:
          description: >-
            Ingress or egress, which is the direction in which the security
            group rule is applied
          enum:
            - egress
            - ingress
          example: ingress
          examples:
            - ingress
          title: Direction
          type: string
        ethertype:
          anyOf:
            - enum:
                - IPv4
                - IPv6
              type: string
            - type: 'null'
          description: >-
            Must be IPv4 or IPv6, and addresses represented in CIDR must match
            the ingress or egress rules.
          examples:
            - IPv4
          title: Ethertype
        port_range_max:
          anyOf:
            - maximum: 65535
              minimum: 0
              type: integer
            - type: 'null'
          description: >-
            The maximum port number in the range that is matched by the security
            group rule
          examples:
            - 80
          title: Port Range Max
        port_range_min:
          anyOf:
            - maximum: 65535
              minimum: 0
              type: integer
            - type: 'null'
          description: >-
            The minimum port number in the range that is matched by the security
            group rule
          examples:
            - 80
          title: Port Range Min
        protocol:
          $ref: '#/components/schemas/SecurityGroupProtocolEnum'
          description: Protocol
          examples:
            - tcp
        remote_group_id:
          anyOf:
            - format: uuid4
              type: string
            - type: 'null'
          description: The remote group UUID to associate with this security group rule
          examples:
            - 00000000-0000-4000-8000-000000000000
          title: Remote Group Id
        remote_ip_prefix:
          anyOf:
            - format: ipvanynetwork
              type: string
            - type: 'null'
          description: The remote IP prefix that is matched by this security group rule
          examples:
            - 10.0.0.0/8
          title: Remote Ip Prefix
        security_group_id:
          description: Parent security group of this rule
          example: 00000000-0000-4000-8000-000000000000
          examples:
            - 00000000-0000-4000-8000-000000000000
          format: uuid4
          title: Security Group Id
          type: string
      required:
        - security_group_id
        - direction
      title: ChangeSecurityGroupRuleSerializer
      type: object
    SecurityGroupRuleSerializer:
      properties:
        created_at:
          description: Datetime when the rule was created
          example: 2019-06-18T11:56:16+0000
          examples:
            - 2019-06-18T11:56:16+0000
          format: date-time
          title: Created At
          type: string
        description:
          anyOf:
            - type: string
            - type: 'null'
          description: Rule description
          examples:
            - Some description
          title: Description
        direction:
          description: >-
            Ingress or egress, which is the direction in which the security
            group rule is applied
          enum:
            - egress
            - ingress
          title: Direction
          type: string
        ethertype:
          anyOf:
            - enum:
                - IPv4
                - IPv6
              type: string
            - type: 'null'
          description: >-
            Must be IPv4 or IPv6, and addresses represented in CIDR must match
            the ingress or egress rules.
          examples:
            - IPv4
          title: Ethertype
        id:
          description: The ID of the security group rule
          example: 00000000-0000-4000-8000-000000000000
          examples:
            - 00000000-0000-4000-8000-000000000000
          format: uuid4
          title: Id
          type: string
        port_range_max:
          anyOf:
            - maximum: 65535
              minimum: 0
              type: integer
            - type: 'null'
          description: >-
            The maximum port number in the range that is matched by the security
            group rule
          examples:
            - 80
          title: Port Range Max
        port_range_min:
          anyOf:
            - maximum: 65535
              minimum: 0
              type: integer
            - type: 'null'
          description: >-
            The minimum port number in the range that is matched by the security
            group rule
          examples:
            - 80
          title: Port Range Min
        protocol:
          anyOf:
            - $ref: '#/components/schemas/SecurityGroupProtocolEnum'
            - type: 'null'
          description: Protocol
          examples:
            - tcp
        remote_group_id:
          anyOf:
            - format: uuid4
              type: string
            - type: 'null'
          description: The remote group UUID to associate with this security group rule
          examples:
            - - 00000000-0000-4000-8000-000000000000
          title: Remote Group Id
        remote_ip_prefix:
          anyOf:
            - format: ipvanynetwork
              type: string
            - type: 'null'
          description: The remote IP prefix that is matched by this security group rule
          examples:
            - 10.0.0.0/8
          title: Remote Ip Prefix
        revision_number:
          description: The revision number of the resource
          example: 0
          examples:
            - 0
          title: Revision Number
          type: integer
        security_group_id:
          description: The security group ID to associate with this security group rule
          example: 00000000-0000-4000-8000-000000000000
          examples:
            - 00000000-0000-4000-8000-000000000000
          format: uuid4
          title: Security Group Id
          type: string
        updated_at:
          description: Datetime when the rule was last updated
          example: 2019-06-18T11:57:00+0000
          examples:
            - 2019-06-18T11:57:00+0000
          format: date-time
          title: Updated At
          type: string
      required:
        - id
        - security_group_id
        - created_at
        - updated_at
        - revision_number
        - ethertype
        - description
        - remote_group_id
        - port_range_min
        - port_range_max
        - remote_ip_prefix
        - protocol
        - direction
      title: SecurityGroupRuleSerializer
      type: object
    SecurityGroupProtocolEnum:
      enum:
        - ah
        - any
        - dccp
        - egp
        - esp
        - gre
        - icmp
        - igmp
        - ipencap
        - ipip
        - ipv6-encap
        - ipv6-frag
        - ipv6-icmp
        - ipv6-nonxt
        - ipv6-opts
        - ipv6-route
        - ospf
        - pgm
        - rsvp
        - sctp
        - tcp
        - udp
        - udplite
        - vrrp
      title: SecurityGroupProtocolEnum
      type: string
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````